package part2

import (
	"gitlab.com/auroq/advent-of-code/advent-of-code-2020/pkg/challenges/day20/pocket"
	"strconv"
	"testing"
)

func TestPart2_Run(t *testing.T) {
	var inputs = []string{
		"Tile 2311:",
		"..##.#..#.",
		"##..#.....",
		"#...##..#.",
		"####.#...#",
		"##.##.###.",
		"##...#.###",
		".#.#.#..##",
		"..#....#..",
		"###...#.#.",
		"..###..###",
		"",
		"Tile 1951:",
		"#.##...##.",
		"#.####...#",
		".....#..##",
		"#...######",
		".##.#....#",
		".###.#####",
		"###.##.##.",
		".###....#.",
		"..#.#..#.#",
		"#...##.#..",
		"",
		"Tile 1171:",
		"####...##.",
		"#..##.#..#",
		"##.#..#.#.",
		".###.####.",
		"..###.####",
		".##....##.",
		".#...####.",
		"#.##.####.",
		"####..#...",
		".....##...",
		"",
		"Tile 1427:",
		"###.##.#..",
		".#..#.##..",
		".#.##.#..#",
		"#.#.#.##.#",
		"....#...##",
		"...##..##.",
		"...#.#####",
		".#.####.#.",
		"..#..###.#",
		"..##.#..#.",
		"",
		"Tile 1489:",
		"##.#.#....",
		"..##...#..",
		".##..##...",
		"..#...#...",
		"#####...#.",
		"#..#.#.#.#",
		"...#.#.#..",
		"##.#...##.",
		"..##.##.##",
		"###.##.#..",
		"",
		"Tile 2473:",
		"#....####.",
		"#..#.##...",
		"#.##..#...",
		"######.#.#",
		".#...#.#.#",
		".#########",
		".###.#..#.",
		"########.#",
		"##...##.#.",
		"..###.#.#.",
		"",
		"Tile 2971:",
		"..#.#....#",
		"#...###...",
		"#.#.###...",
		"##.##..#..",
		".#####..##",
		".#..####.#",
		"#..#.#..#.",
		"..####.###",
		"..#.#.###.",
		"...#.#.#.#",
		"",
		"Tile 2729:",
		"...#.#.#.#",
		"####.#....",
		"..#.#.....",
		"....#..#.#",
		".##..##.#.",
		".#.####...",
		"####.#.#..",
		"##.####...",
		"##..#.##..",
		"#.##...##.",
		"",
		"Tile 3079:",
		"#.#.#####.",
		".#..######",
		"..#.......",
		"######....",
		"####.#..#.",
		".#...#.##.",
		"#.#####.##",
		"..#.###...",
		"..#.......",
		"..#.###...",
	}
	expected := 273
	part2 := Part2{}
	actual, err := part2.Run(inputs)
	if err != nil {
		if err.Error() == "challenge not yet implemented" {
			t.Skip("challenge not yet implemented")
		}
		t.Error(err)
	}
	if actual != expected {
		t.Fatalf("expected: %d, actual: %d", expected, actual)
	}
}

func TestCountSeaMonsters(t *testing.T) {
	grid := pocket.NewGrid([]string{
		"..................#.....",
		"#....##....##....###....",
		".#..#..#..#..#..#.......",
		".####...#####..#...###..",
		"#####..#..#.#.####..#.#.",
		".#.#...#.###...#.##.##..",
		"#.#.##.###.#.##.##.#####",
		"..##.###.####..#.####.##",
		"...#.#..##.##...#..#..##",
		"#.##.#..#.#..#..##.#.#..",
		".###.##.....#...###.#...",
		"#.####.#.#....##.#..#.#.",
		"##...#..#....#..#...####",
		"..#.##...###..#.#####..#",
		"....#.##.#.#####....#...",
		"..##.##.###.....#.##..#.",
		"#...#...###..####....##.",
		".#.##...#.##.#.#.###...#",
		"#.###.#..####...##..#...",
		"#.###...#.##...#.######.",
		".###.###.#######..#####.",
		"..##.#..#..#.#######.###",
		"#.#..##.########..#..##.",
		"#.#####..#.#...##..#....",
		"#....##..#.#########..##",
		"#...#.....#..##...###.##",
		"#..###....##.#...##.##.#",
		"......................#.",
		"....#....##....##....###",
		".....#..#..#..#..#..#...",
	})
	expected := 4
	actual := CountSeaMonsters(grid)
	if actual != expected {
		t.Fatalf("expected: %d, actual: %d", expected, actual)
	}
}

func TestCountSeaMonstersHorizontally(t *testing.T) {
	tests := []struct {
		lines    []string
		expected int
	}{
		{
			[]string{
				".#.#...#.###...#.##.##..",
				".#.#...#.###...#.##.##..",
				"#.#.##.###.#.##.##.#####",
				"..##.###.####..#.####.##",
				"..##.###.####..#.####.##",
			}, 0,
		},
		{
			[]string{
				"#.#.##.###.#.##.##.#####",
				"..##.###.####..#.####.##",
			}, 0,
		},
		{
			[]string{
				"...................#.",
				".#....##....##....###",
				"..#..#..#..#..#..#...",
			}, 1,
		},
		{
			[]string{
				"....................#....",
				"..#....##....##....###...",
				"...#..#..#..#..#..#......",
			}, 1,
		},
		{
			[]string{
				"....................#.",
				"..#....##....##....###",
				"...#..#..#..#..#..#...",
			}, 1,
		},
		{
			[]string{
				"..................#.",
				"#....##....##....###",
				".#..#..#..#..#..#...",
			}, 1,
		},
		{
			[]string{
				".#.#...#.###...#.##.##..",
				"#.#.##.###.#.##.##.#####",
				"..##.###.####..#.####.##",
			}, 1,
		},
		{
			[]string{
				"...#.#..##.##...#..#..##",
				"#.##.#..#.#..#..##.#.#..",
				".###.##.....#...###.#...",
			}, 0,
		},
		{
			[]string{
				"#.####.#.#....##.#..#.#.",
				"##...#..#....#..#...####",
				"..#.##...###..#.#####..#",
			}, 0,
		},
		{
			[]string{
				"....#.##.#.#####....#...",
				"..##.##.###.....#.##..#.",
				"#...#...###..####....##.",
			}, 0,
		},
		{
			[]string{
				"#.###...#.##...#.######.",
				".###.###.#######..#####.",
				"..##.#..#..#.#######.###",
			}, 1,
		},
		{
			[]string{
				"..................#...................#.",
				"#....##....##....####....##....##....###",
				".#..#..#..#..#..#....#..#..#..#..#..#...",
			}, 2,
		},
	}
	for i, test := range tests {
		test := test
		t.Run(strconv.Itoa(i), func(t *testing.T) {
			expected := test.expected
			actual := countSeaMonstersHorizontally(test.lines)
			if actual != expected {
				t.Fatalf("expected: %d, actual: %d", expected, actual)
			}
		})
	}
}
